> ## Documentation Index
> Fetch the complete documentation index at: https://docs.semgrep.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List Policy Rules

> List the rules for a given policy.



## OpenAPI

````yaml /public_v2.openapi.yaml get /api/policies/v1/deployments/{deploymentId}/{policyId}/rules
openapi: 3.0.3
info:
  title: Semgrep API
  description: >-
    The API v2 is currently a work in progress as we expand and improve our
    platform capabilities. There are no current plans to deprecate the [v1
    API](/api/v1/docs) – we remain committed to supporting existing integrations
    and will ensure that all v1 use cases are fully supported in v2 before any
    deprecation occurs.

    ## API Maturity Levels


    Each endpoint in the v2 API is marked with a maturity badge to help you
    understand its current state:


    🚧 **Experimental** - Use at your own risk. This endpoint was not originally
    designed for third-party use or is under active development. Expect
    significant breaking changes.


    ⚠️ **Beta** - This endpoint is being refined. We will communicate breaking
    changes to Beta partners as we tweak the implementation.


    ✅ **Stable** - No breaking changes will be made to this API. You can
    confidently build production integrations against these endpoints.


    We recommend using Stable endpoints for production applications and treating
    Experimental/Beta endpoints as previews of upcoming functionality. This API
    is documented in the **OpenAPI format**.


    # Authentication


    The API supports authentication with an API token with the "Web API"
    permission, without limited scopes of access.


    You can provision an API token [from the Settings
    page](https://semgrep.dev/orgs/-/settings/tokens).


    # Terms of Use


    Please note, the materials made available herein are subject to the [Semgrep
    Terms of Use](https://semgrep.dev/resources/website-terms/), and your access
    or use of any of the same is your acknowledgment and acceptance of the such
    terms.


    <br>


    ___
  contact:
    email: support@semgrep.com
  version: v2.0.0.alpha
  x-logo:
    url: https://semgrep.dev/images/SemgrepLogoWithTextWithMargin.svg
    backgroundColor: '#fafafa'
    altText: Semgrep logo
servers: []
security: []
tags:
  - name: AiFixJobsService
    description: Manage AI fix jobs for automated security fixes
    x-displayName: AI Fix Jobs
    x-group: AI Fix Jobs
  - name: AiTasksService
    description: Manage AI tasks, such as triage, auto-triage, and issue tagging backfill
    x-displayName: Ai Tasks
    x-group: Ai Tasks
  - name: AutofixService
    description: Trigger automated fixes for SAST, AI SAST, and SCA issues.
    x-displayName: Autofix
    x-group: Autofix
  - name: AutomationsService
    description: >-
      Automations are a way to automatically take actions on findings based on
      certain conditions.
    x-displayName: Automations
    x-group: Automations
  - name: AutotriageFeedbackService
    description: Feedback for the quality of autotriage, guidance or autofix
    x-displayName: Autotriage Feedback
    x-group: Autotriage Feedback
  - name: ChecklistService
    description: Manage onboarding checklist
    x-displayName: Onboarding Checklist
    x-group: Onboarding Checklist
  - name: DeploymentProductsService
    description: Manage deployment product configurations.
    x-displayName: Deployment Products
    x-group: Deployment Products
  - name: DeploymentService
    description: Manage deployment and its resources.
    x-displayName: Deployment
    x-group: Deployment
  - name: DeploymentSsoProvidersService
    description: Manage Deployment SSO Providers
    x-displayName: Deployment SSO Providers
    x-group: Deployment SSO Providers
  - name: DeploymentTagService
    description: Assign tags to a deployment.
    x-displayName: Deployment Tags
    x-group: Deployment Tags
  - name: DeploymentsService
    description: >-
      Deployments encapsulate your organization's security organization, with
      multiple projects, policies, and integrations. As the root object of the
      organization, they're similarly the root object of the API.
    x-displayName: Deployments
    x-group: Deployments
  - name: EditorService
    description: Run Semgrep patterns against target code in the editor playground
    x-displayName: Editor
    x-group: Editor
  - name: ExternalTicketingService
    description: APIs that power the External Ticketing experience.
    x-displayName: External Ticketing
    x-group: External Ticketing
  - name: FeatureRolloutsService
    description: View feature flags rolled out to all deployments
    x-displayName: Feature Rollouts
    x-group: Feature Rollouts
  - name: IgnoresService
    description: >-
      API for managing global ignores. See
      https://semgrep.dev/docs/ignoring-files-folders-code
    x-displayName: Global Ignores
    x-group: Global Ignores
  - name: InfrastructureConfigurationsService
    description: Infrastructure configuration information.
    x-displayName: Infrastructure Configurations
    x-group: Infrastructure Configurations
  - name: IssuesService
    description: Manage findings found by Semgrep scans
    x-displayName: Issues
    x-group: Issues
  - name: ManagedScanSettingsService
    description: Settings that affect all of a deployment's managed scans
    x-displayName: Managed Scan Settings
    x-group: Managed Scan Settings
  - name: MemoriesService
    description: Memories help reduce noise from findings.
    x-displayName: Memories
    x-group: Memories
  - name: MiscService
    description: Miscellaneous endpoints
    x-displayName: Misc
    x-group: Misc
  - name: NotificationRulesService
    description: Setup rules to get notified about new findings
    x-displayName: Notification Rules
    x-group: Notification Rules
  - name: NotificationWebhooksService
    description: Manage webhook endpoints for deployment notifications.
    x-displayName: Notification Webhooks
    x-group: Notification Webhooks
  - name: NotificationsService
    description: Notifications show in-app toasts to users.
    x-displayName: Notifications
    x-group: Notifications
  - name: PoliciesService
    description: >-
      View and manage the Policies of your organization.


      Deployments on the Unified Policies model use the [Policies V2
      API](/api/v2/docs/#tag/PoliciesV2Service) instead; this service stops
      working after the migration.
    x-displayName: Policies
    x-group: Policies
  - name: PoliciesV2Service
    description: >-
      Declarative management of detection and remediation policies for
      deployments on the Unified Policies model. Designed for GitOps-style
      reconciliation: read the current bundle, edit it, preview the diff with a
      dry run, then apply it strictly with optimistic concurrency control.
    x-displayName: Policies V2
    x-group: Policies V2
  - name: ProjectManagedScanSettingsService
    description: Settings that affect a specific project's managed scans
    x-displayName: Projects – Managed Scan Settings
    x-group: Projects – Managed Scan Settings
  - name: ProjectsService
    description: >-
      Projects are groups of files that are scanned by Semgrep. These normally
      correspond to repositories.
    x-displayName: Projects
    x-group: Projects
  - name: ReportsService
    description: APIs for Reporting Dashboards
    x-displayName: Reporting
    x-group: Reporting
  - name: ReviewCommentProductContentService
    description: >-
      Review comment product content is a way to add additional per-product
      information to a review comment.
    x-displayName: Review Comment Product Content
    x-group: Review Comment Product Content
  - name: RuleboardService
    description: >-
      The [Policies API](/api/v2/docs/#tag/PoliciesService) is *strongly*
      recommended. It is also newer than this Ruleboard service. Deployments on
      the Unified Policies model use the [Policies V2
      API](/api/v2/docs/#tag/PoliciesV2Service) instead; this service stops
      working after the migration.


      Manage Ruleboards (sets of policies).
    x-displayName: Ruleboards
    x-group: Ruleboards
  - name: ScansService
    description: View details of scans associated with projects in your organization.
    x-displayName: Scans
    x-group: Scans
  - name: ScmAppsService
    description: >-
      Manage connections to source code management systems (Github, Gitlab,
      etc.)
    x-displayName: Source Code Management (SCM) App
    x-group: Source Code Management (SCM) App
  - name: ScmService
    description: >-
      Manage connections to source code management systems (Github, Gitlab,
      etc.)
    x-displayName: Source Code Management (SCM) Configs
    x-group: Source Code Management (SCM) Configs
  - name: ScmSubscriptionsService
    description: Manage SCM Webhook Subscriptions
    x-displayName: Source Code Management (SCM) Webhooks
    x-group: Source Code Management (SCM) Webhooks
  - name: SlackService
  - name: SmsPackageManagerConfigService
    description: >-
      Manage authentication configurations for package managers used in Supply
      Chain Analysis (SCA) scans.
    x-displayName: Supply Chain - SMS Package Manager Configurations
    x-group: Supply Chain - SMS Package Manager Configurations
  - name: SmsScaResolutionConfigService
    description: >-
      Retrieve custom dependency resolution configurations for lockfileless
      scans.
    x-displayName: Supply Chain - SMS SCA Resolution Configurations
    x-group: Supply Chain - SMS SCA Resolution Configurations
  - name: SupplyChain2Service
    description: >-
      The Supply Chain is all of the dependencies of code, rather than the code
      itself. This service gives information about the supply chain.
    x-displayName: Supply Chain
    x-group: Supply Chain
  - name: SupportService
    description: Create and List Support Cases
    x-displayName: Support Service
    x-group: Support Service
  - name: SurveysService
    description: Retrieve and submit company surveys
    x-displayName: Surveys
    x-group: Surveys
  - name: TasksService
    description: >-
      Many tasks are done asynchronously; this service deals with managing async
      tasks.
    x-displayName: Tasks
    x-group: Tasks
  - name: TeamsService
    description: >-
      Teams are used to manage access control for resources within a deployment.
      For more information visit https://semgrep.dev/docs/deployment/teams.
    x-displayName: Teams
    x-group: Teams
  - name: TokenService
    description: >-
      Tokens are used for programmatic access to the Semgrep Cloud Platform
      APIs.
    x-displayName: Tokens
    x-group: Tokens
  - name: UsersService
    description: Manage user accounts, settings, and organization memberships
    x-displayName: Users Auth Service
    x-group: Users Auth Service
  - name: VersionsService
    description: Semgrep version information
    x-displayName: Versions
    x-group: Versions
  - name: WizCredentialService
    description: Manage Wiz credentials
    x-displayName: Wiz Credentials
    x-group: Wiz Credentials
paths:
  /api/policies/v1/deployments/{deploymentId}/{policyId}/rules:
    get:
      tags:
        - PoliciesService
      summary: List Policy Rules
      description: List the rules for a given policy.
      operationId: PoliciesService_ListPolicyRules
      parameters:
        - name: deploymentId
          in: path
          required: true
          schema:
            example: 123
            type: string
            description: The unique numerical identifier for the deployment.
            format: int64
        - name: policyId
          in: path
          required: true
          schema:
            example: 456
            type: string
            description: >-
              The unique numerical identifier for the policy. Find your policy's
              ID via the [List
              Policies](/api/v2/docs/#tag/PoliciesService/operation/PoliciesService_ListPolicies)
              endpoint.
            format: int64
        - name: cursor
          in: query
          schema:
            type: string
            description: >-
              Cursor to paginate through the rules. Provide a cursor value from
              the response to retrieve the next page.
        - name: limit
          in: query
          schema:
            type: integer
            description: >-
              Page size to paginate through the rules. The default page size is
              `500` and the maximum allowed page size is `2000`.
            format: int64
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/protos.policies.v1.ListPolicyRulesResponse
      security:
        - SemgrepWebToken: []
components:
  schemas:
    protos.policies.v1.ListPolicyRulesResponse:
      type: object
      properties:
        policy:
          $ref: '#/components/schemas/protos.common.v1.Policy'
        rules:
          example:
            - id: '1'
              policyMode: MODE_MONITOR
              path: python.rule.1
              source: SOURCE_COMMUNITY
              severity: SEVERITY_HIGH
              languages:
                - python
              confidence: CONFIDENCE_HIGH
              vulnerabilityClass:
                - Improper Authentication
              rulesets: []
              lastChangeAt: '2024-07-29T22:33:37.380293Z'
              category: security
              owaspCategories:
                - 'A07: Cross-Site Scripting (XSS)'
              technologies:
                - django
                - flask
              cweCategories:
                - 'CWE-918: Server-Side Request Forgery (SSRF)'
              url: https://semgrep.com/r/123/python.rule.1
              registryMaintainer: semgrep
            - id: '2'
              policyMode: MODE_COMMENT
              path: python.rule.shared
              source: SOURCE_PRO
              severity: SEVERITY_MEDIUM
              languages:
                - python
              confidence: CONFIDENCE_HIGH
              vulnerabilityClass:
                - Improper Authentication
              rulesets:
                - comment
                - default
              lastChangeAt: '2024-07-29T22:33:37.380293Z'
              category: security
              owaspCategories:
                - A01:2021 - Broken Access Control
                - 'A07: Cross-Site Scripting (XSS)'
              technologies:
                - django
                - flask
              cweCategories:
                - 'CWE-918: Server-Side Request Forgery (SSRF)'
              url: https://semgrep.com/r/123/python.rule.shared
              registryMaintainer: semgrep
            - id: '3'
              policyMode: MODE_BLOCK
              path: python.rule.custom_rule
              source: SOURCE_CUSTOM
              severity: SEVERITY_MEDIUM
              languages:
                - python
              confidence: CONFIDENCE_HIGH
              vulnerabilityClass:
                - Improper Authentication
              rulesets: []
              lastChangeAt: '2024-07-29T22:33:37.380293Z'
              lastChangeBy: example-user
              category: best-practice
              owaspCategories: []
              technologies:
                - django
                - flask
              cweCategories: []
              url: https://semgrep.com/r/123/python.rule.custom_rule
              registryMaintainer: semgrep
          type: array
          items:
            $ref: '#/components/schemas/protos.common.v1.Rule'
          description: List of Rules for the given Policy.
        cursor:
          example: Pm0ROjIwMjQtMDItMDYgMjA6MDQ6NDguMEDzNzk2fmk6NYTM2zUxOTI
          type: string
          description: Cursor to paginate through the rules.
    protos.common.v1.Policy:
      title: Policy
      type: object
      properties:
        id:
          example: '1'
          type: string
          description: ID of the Policy.
          format: int64
        isDefault:
          example: true
          type: boolean
          description: When True, the Policy applies to all repositories.
        name:
          example: Global Policy
          type: string
          description: Name of the Policy.
        productType:
          example: PRODUCT_TYPE_SAST
          enum:
            - PRODUCT_TYPE_SAST
            - PRODUCT_TYPE_SECRETS
          type: string
          description: |+
            Product type the Policy applies to.

            | value | description |
            |-------|---------------|
            | PRODUCT_TYPE_SAST | The product type for Code rules. |
            | PRODUCT_TYPE_SECRETS | The product type for Secrets rules. |

          format: enum
        slug:
          example: global_policy
          type: string
          description: Sanitized machine-readable name of the Policy.
    protos.common.v1.Rule:
      title: Rule
      type: object
      properties:
        id:
          type: string
          description: ID of the Rule.
          format: int64
        category:
          example: security
          type: string
          description: Category the Rule is associated with.
        confidence:
          example: CONFIDENCE_HIGH
          enum:
            - CONFIDENCE_HIGH
            - CONFIDENCE_MEDIUM
            - CONFIDENCE_LOW
          type: string
          description: |+
            Confidence based on the Rule's false-positive rate.

            | value | description |
            |-------|---------------|
            | CONFIDENCE_HIGH |  |
            | CONFIDENCE_MEDIUM |  |
            | CONFIDENCE_LOW |  |

          format: enum
        cweCategories:
          example:
            - 'CWE-918: Server-Side Request Forgery (SSRF)'
          type: array
          items:
            type: string
          description: The CWE associated with the Rule.
        hasValidators:
          type: boolean
          description: When True, the secrets rule has validators.
        languages:
          example:
            - python
          type: array
          items:
            type: string
          description: Languages the Rule applies to.
        lastChangeAt:
          example: '2024-07-29T22:33:37.380Z'
          type: string
          description: Timestamp of when the Rule was last changed.
          format: date-time
        lastChangeBy:
          type: string
          description: Username of who last changed the Rule.
        owaspCategories:
          example:
            - 'A07: Cross-Site Scripting (XSS)'
          type: array
          items:
            type: string
          description: Owasp categories the Rule is associated with.
        path:
          example: python.rule.1
          type: string
          description: Full path of the Rule.
        policyMode:
          example: MODE_BLOCK
          enum:
            - MODE_MONITOR
            - MODE_COMMENT
            - MODE_BLOCK
            - MODE_DISABLED
          type: string
          description: >+
            Mode behavior: Monitor / Comment / Block / Disabled


            | value | description |

            |-------|---------------|

            | MODE_MONITOR | Monitor mode, silently report findings |

            | MODE_COMMENT | Comment mode, leaves PR comments but does not block
            |

            | MODE_BLOCK | Block mode, leaves PR comments and blocks PR |

            | MODE_DISABLED | Disabled mode, not active |

          format: enum
        registryMaintainer:
          example: semgrep
          type: string
          description: The Registry maintainer associated with the Rule (if applicable).
        rulesets:
          example: []
          type: array
          items:
            type: string
          description: Rulesets to which the Rule belongs (if applicable).
        secretType:
          type: string
          description: The secret type (if applicable).
        severity:
          example: SEVERITY_HIGH
          enum:
            - SEVERITY_HIGH
            - SEVERITY_MEDIUM
            - SEVERITY_LOW
            - SEVERITY_CRITICAL
          type: string
          description: |+
            Severity level ("seriousness" of the finding)

            | value | description |
            |-------|---------------|
            | SEVERITY_HIGH |  |
            | SEVERITY_MEDIUM |  |
            | SEVERITY_LOW |  |
            | SEVERITY_CRITICAL |  |

          format: enum
        source:
          example: SOURCE_COMMUNITY
          enum:
            - SOURCE_PRO
            - SOURCE_COMMUNITY
            - SOURCE_CUSTOM
          type: string
          description: |+
            Source of the Rule

            | value | description |
            |-------|---------------|
            | SOURCE_PRO | From Pro rules |
            | SOURCE_COMMUNITY | From Semgrep Community rules |
            | SOURCE_CUSTOM | From Custom rules |

          format: enum
        technologies:
          example:
            - django
            - flask
          type: array
          items:
            type: string
          description: Technologies the Rule is associated with.
        url:
          type: string
          description: The URL of the Rule.
        vulnerabilityClass:
          example: Improper Authentication
          type: array
          items:
            type: string
          description: Vulnerability classes the Rule is associated with.
  securitySchemes:
    SemgrepWebToken:
      type: http
      description: >-
        Get access to data with your API token. Example header:


        `Authorization: Bearer
        2991e2fb4b540fe75b8f90677b0b892b6314e4961cb001fe6eb452eee248a628`


        The token can be provisioned from the Tokens section in your Settings,
        and requires explicitly enabling `Web API` access.
      scheme: bearer
      bearerFormat: string

````